(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('codemirror')) :
	typeof define === 'function' && define.amd ? define('@webacad/ng-codemirror', ['exports', '@angular/core', '@angular/forms', 'codemirror'], factory) :
	(factory((global.webacad = global.webacad || {}, global.webacad['ng-codemirror'] = {}),global.ng.core,global.ng.forms,global.CodeMirror));
}(this, (function (exports,core,forms,CodeMirror) { 'use strict';

CodeMirror = CodeMirror && CodeMirror.hasOwnProperty('default') ? CodeMirror['default'] : CodeMirror;

var WA_CODEMIRROR_DEFAULTS = new core.InjectionToken('WA_CODEMIRROR_DEFAULTS');
var codemirrorInputOptions = [
    'mode', 'theme', 'lineNumbers', 'viewportMargin',
];
var CodemirrorComponent = /** @class */ (function () {
    function CodemirrorComponent($el, defaults) {
        this.$el = $el;
        this.onChange = function (_) { };
        this.onTouched = function () { };
        this.defaults = defaults || {};
    }
    CodemirrorComponent.prototype.ngOnInit = function () {
        var _this = this;
        var config = Object.assign({}, this.defaults);
        if (typeof this.lineNumbers !== 'undefined') {
            config.lineNumbers = this.lineNumbers;
        }
        if (typeof this.mode !== 'undefined') {
            config.mode = this.mode;
        }
        if (typeof this.theme !== 'undefined') {
            config.theme = this.theme;
        }
        if (typeof this.viewportMargin !== 'undefined') {
            config.viewportMargin = this.viewportMargin;
        }
        if (typeof this.defaultValue !== 'undefined') {
            config.value = this.defaultValue;
        }
        this.codemirror = CodeMirror(this.$el.nativeElement, config);
        this.codemirror.on('change', function (editor) {
            _this.onChange(editor.getValue());
        });
        this.codemirror.on('blur', function () {
            _this.onTouched();
        });
    };
    CodemirrorComponent.prototype.ngOnChanges = function (changes) {
        if (!this.codemirror) {
            return;
        }
        for (var option in changes) {
            if (changes.hasOwnProperty(option) && codemirrorInputOptions.indexOf(option) >= 0) {
                this.codemirror.setOption(option, changes[option].currentValue);
            }
        }
    };
    CodemirrorComponent.prototype.writeValue = function (value) {
        if (this.codemirror) {
            this.codemirror.setValue(value);
        }
        else {
            this.defaultValue = value;
        }
    };
    CodemirrorComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    CodemirrorComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    return CodemirrorComponent;
}());
CodemirrorComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'wa-codemirror',
                template: '',
                providers: [
                    {
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: CodemirrorComponent,
                        multi: true,
                    },
                ],
            },] },
];
CodemirrorComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: undefined, decorators: [{ type: core.Inject, args: [WA_CODEMIRROR_DEFAULTS,] }, { type: core.Optional },] },
]; };
CodemirrorComponent.propDecorators = {
    "mode": [{ type: core.Input },],
    "theme": [{ type: core.Input },],
    "lineNumbers": [{ type: core.Input },],
    "viewportMargin": [{ type: core.Input },],
};
var CodemirrorModule = /** @class */ (function () {
    function CodemirrorModule() {
    }
    return CodemirrorModule;
}());
CodemirrorModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    CodemirrorComponent,
                ],
                exports: [
                    CodemirrorComponent,
                ],
            },] },
];

exports.CodemirrorComponent = CodemirrorComponent;
exports.CodemirrorModule = CodemirrorModule;
exports.WA_CODEMIRROR_DEFAULTS = WA_CODEMIRROR_DEFAULTS;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=webacad-ng-codemirror.umd.js.map
